Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 9217)
@@ -18,5 +18,4 @@
 """ Viewing components for Kofa objects.
 """
-import copy
 import csv
 import grok
@@ -24,6 +23,4 @@
 import re
 import sys
-import time
-import re
 from urllib import urlencode
 from zope import schema
@@ -35,11 +32,9 @@
     getUtilitiesFor,
     )
-#from zope.component.interfaces import Invalid
 from zope.event import notify
-from zope.securitypolicy.interfaces import (
-    IPrincipalRoleManager, IPrincipalRoleMap)
+from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from zope.session.interfaces import ISession
 from zope.password.interfaces import IPasswordManager
-from waeup.kofa.browser import (
+from waeup.kofa.browser.layout import (
     KofaPage, KofaForm, KofaEditFormPage, KofaAddFormPage,
     KofaDisplayFormPage, NullValidator)
@@ -48,7 +43,8 @@
     IDepartment, IDepartmentAdd, ICourse, ICourseAdd, ICertificate,
     ICertificateAdd, ICertificateCourse, ICertificateCourseAdd,
-    ICaptchaManager)
+    ICaptchaManager, IChangePassword)
 from waeup.kofa.browser.layout import jsaction, action, UtilityView
-from waeup.kofa.browser.resources import warning, datepicker, tabs, datatable
+from waeup.kofa.browser.resources import (
+    warning, tabs, datatable)
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.interfaces import(
@@ -56,16 +52,14 @@
     IKofaXMLImporter, IKofaXMLExporter, IBatchProcessor,
     ILocalRolesAssignable, DuplicationError, IConfigurationContainer,
-    ISessionConfiguration, ISessionConfigurationAdd,
-    IPasswordValidator, IContactForm, IKofaUtils, ICSVExporter,
-    IChangePassword)
+    ISessionConfiguration, ISessionConfigurationAdd, IJobManager,
+    IPasswordValidator, IContactForm, IKofaUtils, ICSVExporter,)
 from waeup.kofa.permissions import (
     get_users_with_local_roles, get_all_roles, get_all_users)
+
 from waeup.kofa.students.catalog import search as searchstudents
 from waeup.kofa.university.catalog import search
 from waeup.kofa.university.vocabularies import course_levels
 from waeup.kofa.authentication import LocalRoleSetEvent
-#from waeup.kofa.widgets.restwidget import ReSTDisplayWidget
 from waeup.kofa.widgets.htmlwidget import HTMLDisplayWidget
-from waeup.kofa.authentication import get_principal_role_manager
 from waeup.kofa.utils.helpers import get_user_account
 from waeup.kofa.mandates.mandate import PasswordMandate
@@ -797,5 +791,4 @@
     def delFiles(self, **data):
         form = self.request.form
-        logger = self.context.logger
         if form.has_key('val_id'):
             child_id = form['val_id']
@@ -1196,8 +1189,4 @@
         return False
 
-    @property
-    def nextstep(self):
-        return self.url(self.context, '@@import4')
-
     def update(self, headerfield=None, back2=None, cancel=None, proceed=None):
         datatable.need()
@@ -1390,5 +1379,6 @@
     label = _('Download portal data as CSV file')
     pnav = 0
-    export_button = _(u'Download')
+    export_button = _(u'Create CSV file')
+    _running_exports = None
 
     def getExporters(self):
@@ -1398,9 +1388,57 @@
         return sorted(title_name_tuples)
 
-    def update(self, export=None, exporter=None):
-        if None in (export, exporter):
-            return
-        self.redirect(
-            self.url(self.context, 'export.csv') + '?exporter=%s' % exporter)
+    def job_finished(self, status):
+        return status == 'completed'
+
+    def getRunningExports(self):
+        """Returns running exports as list of tuples.
+
+        Only exports triggered by the current user (identified by
+        principal.id) are returned.
+
+        Each tuple has the form (<STATUS>, <STATUS_TITLE>, <EXPORTER_NAME>).
+
+        ``STATUS``:
+           the status as machine readable string (something like
+           ``'completed'``)
+
+        ``STATUS_TITLE``:
+           status of export as translated string.
+
+        ``EXPORTER_NAME``:
+           string representing the exporter title used when triggering
+           the export job.
+        """
+        if self._running_exports is None:
+            self._running_exports = self._getRunningExports()
+        return self._running_exports
+
+    def _getRunningExports(self):
+        result = self.context.get_export_jobs_status(self.user_id)
+        return result
+
+    def update(self, export=None, start_export=None, exporter=None,
+               discard=None, download=None):
+        self.user_id = self.request.principal.id
+        if discard:
+            myjobs = self.context.get_running_export_jobs(self.user_id)
+            for entry in myjobs:
+                self.context.delete_export_entry(entry)
+                self.flash(_('Discarded export result'))
+            return
+        if download:
+            myjobs = self.context.get_running_export_jobs(self.user_id)
+            if not len(myjobs):
+                self.flash(_('This export was already discarded.'))
+                return
+            job_id = myjobs[0][0]
+            self.redirect(
+                self.url(self.context, 'export.csv') + '?job_id=%s' % job_id)
+            return
+        if None in (start_export, exporter):
+            return
+        job_id = self.context.start_export_job(
+            exporter, self.request.principal.id)
+        self.redirect(self.url(self.context, 'export'))
         return
 
@@ -1410,20 +1448,28 @@
     grok.require('waeup.manageDataCenter')
 
-    def render(self, exporter=None):
-        if exporter is None:
-            return
-        ob_class = self.__implemented__.__name__.replace('waeup.kofa.','')
-        self.context.logger.info(
-            '%s - exported: %s' % (ob_class, exporter))
-        exporter = getUtility(ICSVExporter, name=exporter)
-        csv_data = exporter.export_all(grok.getSite())
-        #csv_data.seek(0)
+    def render(self, exporter=None, job_id=None):
+
+        manager = getUtility(IJobManager)
+        job = manager.get(job_id)
+        if job is None:
+            return
+        if hasattr(job.result, 'traceback'):
+            # XXX: Some error happened. Do something more approriate here...
+            return
+        path = job.result
+        if not os.path.exists(path):
+            # XXX: Do something more appropriate here...
+            return
+        result = open(path, 'rb').read()
+        acronym = grok.getSite()['configuration'].acronym.replace(' ','')
+        filename = "%s_%s" % (acronym, os.path.basename(path))
         self.response.setHeader(
             'Content-Type', 'text/csv; charset=UTF-8')
-        acronym = grok.getSite()['configuration'].acronym.replace(' ','')
-        filename = "%s%s.csv" % (acronym, exporter.title.title().replace(' ',''))
         self.response.setHeader(
-            'Content-Disposition:', 'attachment; filename="%s' % filename)
-        return csv_data
+            'Content-Disposition', 'attachment; filename="%s' % filename)
+        # remove job and running_exports entry from context
+        self.context.delete_export_entry(
+            self.context.entry_from_job_id(job_id))
+        return result
 
 class ExportXMLPage(grok.View):
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/resources.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/resources.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/resources.py	(revision 9217)
@@ -302,2 +302,13 @@
     waeup_kofa, 'recaptcha_white.js'
     )
+
+#: A page reloader (reloads after 3 secs)
+page_reloader = ResourceInclusion(
+    waeup_kofa, 'page_reloader.js', depends=[jquery])
+
+#: Disables page reloader (which is triggered by a JavaScript timer).
+page_not_reloader = ResourceInclusion(
+    waeup_kofa, 'page_not_reloader.js', depends=[jquery])
+
+loadbar = ResourceInclusion(
+    waeup_kofa, 'loadbar.js', depends=[jquery])
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/static/loadbar.js
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/static/loadbar.js	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/static/loadbar.js	(revision 9217)
@@ -0,0 +1,23 @@
+
+var loadbar_interval = null;
+$(document).ready(
+    function update() {
+	$.getJSON(
+	    $("#status_url").attr("value"),
+	    {},
+	    function(data) {
+		$('input[name="reload"]').remove();
+		clearInterval(loadbar_interval);
+		$("#loadbar").html(data.html);
+		if (data.reload == true) {
+		    if ($('input[name="download"]').attr("value") == null) {
+			location.reload();
+		    }
+		}
+		if (data.interval != 0) {
+		    loadbar_interval = setInterval(update, data.interval);
+		}
+	    }
+	)
+    }
+)
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_not_reloader.js
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_not_reloader.js	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_not_reloader.js	(revision 9217)
@@ -0,0 +1,8 @@
+$(document).ready(function() {
+    if(window.top==window) {
+	// you're not in a frame so you reload the site
+	window.clearTimeout('location.reload()'); //reloads after 1.5 seconds
+    } else {
+	//you're inside a frame, so you stop reloading
+    }
+});
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_reloader.js
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_reloader.js	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/static/page_reloader.js	(revision 9217)
@@ -0,0 +1,8 @@
+$(document).ready(function() {
+    if(window.top==window) {
+	// you're not in a frame so you reload the site
+	window.setTimeout('location.reload()', 1500); //reloads after 1.5 seconds
+    } else {
+	//you're inside a frame, so you stop reloading
+    }
+});
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_async.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_async.py	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_async.py	(revision 9217)
@@ -0,0 +1,174 @@
+import os
+import shutil
+import tempfile
+import transaction
+from zc.async.testing import wait_for_result
+from zope.component import getUtility
+from zope.component.hooks import setSite
+from zope.security.interfaces import Unauthorized
+from zope.testbrowser.testing import Browser
+from waeup.kofa.app import University
+from waeup.kofa.async import AsyncJob, get_job_id
+from waeup.kofa.interfaces import IJobManager
+from waeup.kofa.testing import FunctionalTestCase, FunctionalLayer
+from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
+
+def fake_get_export_jobs_status(user_id=None):
+    return [('completed', 'Completed', 'my_exporter'),]
+
+def dummy_func():
+    return 42
+
+class AsyncBrowserTests(FunctionalAsyncTestCase):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(AsyncBrowserTests, self).setUp()
+        self.workdir = tempfile.mkdtemp()
+        self.storage = os.path.join(self.workdir, 'storage')
+        os.mkdir(self.storage)
+        app = University()
+        app['datacenter'].setStoragePath(self.storage)
+
+        # Prepopulate the ZODB...
+        self.getRootFolder()['app'] = app
+        # we add the site immediately after creation to the
+        # ZODB. Catalogs and other local utilities are not setup
+        # before that step.
+        self.app = self.getRootFolder()['app']
+        # Set site here. Some of the following setup code might need
+        # to access grok.getSite() and should get our new app then
+        setSite(app)
+        self.browser = Browser()
+        self.browser.handleErrors = False
+        self.datacenter_path = 'http://localhost/app/datacenter'
+
+    def tearDown(self):
+        super(AsyncBrowserTests, self).tearDown()
+        shutil.rmtree(self.workdir)
+
+class JobViewTests(AsyncBrowserTests):
+    # Tests for the view of single jobs
+    overview_path = 'http://localhost/app/jobs'
+
+    def setUp(self):
+        super(JobViewTests, self).setUp()
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+
+    def start_job(self):
+        # helper that starts a job in background and returns the job
+        manager = getUtility(IJobManager)
+        job = AsyncJob(dummy_func)
+        manager.put(job, site=self.getRootFolder())
+        return job
+
+    def test_get_job_view(self):
+        # we can get a job on a view
+        self.browser.open(self.overview_path)
+        job = self.start_job()
+        wait_for_result(job)
+        self.browser.open(self.overview_path)
+        job_id = get_job_id(job)
+        link = self.browser.getLink(job_id)
+        expected_url = 'http://localhost/app/jobs/%s' % job_id
+        self.assertEqual(link.url, expected_url)
+        link.click()
+        self.assertEqual(self.browser.headers['status'], '200 Ok')
+        return
+
+    def test_anonymous_forbidden(self):
+        # we need some permissions to get a job view
+        transaction.commit() # make sure the 'app' is stored in ZODB
+        job = self.start_job()
+        wait_for_result(job)
+        job_id = get_job_id(job)
+        link_url = 'http://localhost/app/jobs/%s' % job_id
+
+        # get a new browser, where we're not authenticated
+        browser = Browser()
+        browser.handleErrors = False
+        self.assertRaises(Unauthorized, browser.open, link_url)
+        return
+
+class JobOverviewTests(AsyncBrowserTests):
+    # Tests for the job overview page of universities
+    overview_path = 'http://localhost/app/jobs'
+
+    def setUp(self):
+        super(JobOverviewTests, self).setUp()
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+
+    def start_job(self):
+        # helper that start a job in background and returns the job
+        manager = getUtility(IJobManager)
+        job = AsyncJob(dummy_func)
+        manager.put(job, site=self.getRootFolder())
+        return job
+
+    def test_job_get(self):
+        # we can get the overview page
+        self.browser.open(self.overview_path)
+        self.assertTrue("Running and Completed Jobs" in self.browser.contents)
+        self.assertEqual(self.browser.headers['status'], '200 Ok')
+        return
+
+    def test_anonymous_forbidden(self):
+        # anonymous user will be kept out
+        browser = Browser() # get a browser w/o credentials set
+        browser.handleErrors = False
+        self.assertRaises(Unauthorized, browser.open, self.overview_path)
+        return
+
+    def test_job_reload(self):
+        # we can reload the overview page
+        self.browser.open(self.overview_path)
+        self.browser.getControl('reload').click()
+        self.assertTrue("Running and Completed Jobs" in self.browser.contents)
+        self.assertEqual(self.browser.headers['status'], '200 Ok')
+        return
+
+    def test_jobs_appear(self):
+        # any job running will appear
+        self.browser.open(self.overview_path)
+        job = self.start_job()
+        wait_for_result(job)
+        self.browser.getControl('reload').click()
+        self.assertEqual(self.browser.headers['status'], '200 Ok')
+        self.assertTrue('status: Completed' in self.browser.contents)
+        return
+
+    def test_job_removal(self):
+        # we can remove jobs via the overview page
+        self.browser.open(self.overview_path)
+        job = self.start_job()
+        wait_for_result(job)
+        self.browser.getControl('reload').click()
+        self.assertEqual(len(list(getUtility(IJobManager).jobs())), 1)
+        self.browser.getControl('Remove').click()
+        self.assertEqual(self.browser.headers['status'], '200 Ok')
+        self.assertTrue('Removed job' in self.browser.contents)
+        self.assertEqual(len(list(getUtility(IJobManager).jobs())), 0)
+        return
+
+class DataCenterJSONTests(AsyncBrowserTests):
+
+    def test_status_plain(self):
+        # if no job was triggered, no need to update something.
+        path = '%s/status' % self.datacenter_path
+        self.browser.open(path)
+        self.assertEqual(self.browser.headers['content-type'],
+                         'application/json')
+        self.assertEqual(self.browser.contents,
+                         '{"reload": false, "interval": 0, "html": ""}')
+        return
+
+    def test_status_completed(self):
+        # if all jobs are completed, we should reload the page
+        self.app[
+            'datacenter'].get_export_jobs_status = fake_get_export_jobs_status
+        path = '%s/status' % self.datacenter_path
+        self.browser.open(path)
+        self.assertEqual(self.browser.contents,
+                         '{"reload": true, "interval": 0, "html": ""}')
+        return
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 9217)
@@ -21,19 +21,14 @@
 import shutil
 import tempfile
-import pytz
-from datetime import datetime, timedelta
-from StringIO import StringIO
 import os
-import grok
-from zope.event import notify
-from zope.component import createObject, queryUtility
+from zc.async.testing import wait_for_result
+from zope.component import createObject, getUtility
 from zope.component.hooks import setSite, clearSite
-from zope.catalog.interfaces import ICatalog
 from zope.security.interfaces import Unauthorized
-from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from zope.testbrowser.testing import Browser
-from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from waeup.kofa.testing import FunctionalLayer, FunctionalTestCase
 from waeup.kofa.app import University
+from waeup.kofa.interfaces import IJobManager
+from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
 from waeup.kofa.university.faculty import Faculty
 from waeup.kofa.university.department import Department
@@ -106,5 +101,4 @@
         shutil.rmtree(self.dc_root)
 
-
 class DataCenterUITests(UniversitySetup):
     # Tests for DataCenter class views and pages
@@ -149,5 +143,27 @@
         return
 
-    def test_export(self):
+
+class DataCenterUIExportTests(UniversitySetup, FunctionalAsyncTestCase):
+    # Tests for DataCenter class views and pages
+
+    layer = FunctionalLayer
+
+    def wait_for_export_job_completed(self):
+        # helper function waiting until the current export job is completed
+        manager = getUtility(IJobManager)
+        job_id = self.app['datacenter'].running_exports[0][0]
+        job = manager.get(job_id)
+        wait_for_result(job)
+        return job_id
+
+    def stored_in_datacenter(self, job_id):
+        # tell whether job_id is stored in datacenter's running jobs list
+        for entry in list(self.app['datacenter'].running_exports):
+            if entry[0] == job_id:
+                return True
+        return False
+
+    def test_export_start(self):
+        # we can trigger export file creation
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
         self.browser.open(self.datacenter_path)
@@ -156,18 +172,52 @@
         self.browser.getLink("Export data").click()
         self.browser.getControl(name="exporter").value = ['faculties']
+        self.browser.getControl("Create CSV file").click()
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        return
+
+    def test_export_download(self):
+        # we can download a generated export result
+        self.test_export_start()
+        # while the export file is created, we get a reload button
+        # (or a loading bar if javascript is enabled)...
+        self.browser.getControl("Reload").click()
+        # ...which is displayed as long as the job is not finished.
+        # When the job is finished and we reload the page...
+        job_id = self.wait_for_export_job_completed()
+        try:
+            self.browser.getControl("Reload").click()
+        except LookupError:
+            # if the job completed very fast, we will get the download
+            # link immediately
+            pass
+        # ...we can download the result
         self.browser.getControl("Download").click()
-        self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.assertEqual(self.browser.headers['Content-Type'],
+        self.assertEqual(self.browser.headers['content-type'],
                          'text/csv; charset=UTF-8')
-        self.assertTrue ('WAeUP.KofaFaculties.csv' in
-            self.browser.headers['content-disposition'])
+        self.assertEqual(self.browser.headers['content-disposition'],
+                         'attachment; filename="WAeUP.Kofa_faculties.csv')
         self.assertEqual(self.browser.contents,
             'code,title,title_prefix,users_with_local_roles\r\n'
             'fac1,Unnamed Faculty,faculty,[]\r\n')
-        logfile = os.path.join(
-            self.app['datacenter'].storage, 'logs', 'datacenter.log')
-        logcontent = open(logfile).read()
-        self.assertTrue('zope.mgr - browser.pages.ExportCSVView - '
-                        'exported: faculties' in logcontent)
+
+        # after download, the job and the result file are removed
+        manager = getUtility(IJobManager)
+        result = manager.get(job_id)
+        self.assertEqual(result, None)
+        self.assertEqual(self.stored_in_datacenter(job_id), False)
+        #logfile = os.path.join(
+        #    self.app['datacenter'].storage, 'logs', 'datacenter.log')
+        #logcontent = open(logfile).read()
+        #self.assertTrue('zope.mgr - browser.pages.ExportCSVView - '
+        #                'exported: faculties' in logcontent)
+        return
+
+    def test_export_discard(self):
+        # we can discard a generated export result
+        self.test_export_start()
+        self.wait_for_export_job_completed()
+        self.browser.open(self.datacenter_path + '/@@export')
+        self.browser.getControl("Discard").click()
+        self.assertTrue('Discarded export result' in self.browser.contents)
         return
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/catalog.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/catalog.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/catalog.py	(revision 9217)
@@ -19,6 +19,4 @@
 """
 import grok
-from grok import index
-from hurry.query import Eq
 from hurry.query.interfaces import IQuery
 from hurry.query.query import Query
@@ -26,6 +24,4 @@
 from zope.component import getUtility
 from zope.intid.interfaces import IIntIds
-
-from waeup.kofa.app import University
 from waeup.kofa.interfaces import IQueryResultItem
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/configure.zcml
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/configure.zcml	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/configure.zcml	(revision 9217)
@@ -3,19 +3,8 @@
            xmlns:i18n="http://namespaces.zope.org/i18n">
 
-  <!-- This will load and configure most packages we need. -->
+  <include package="waeup.kofa" file="locales.zcml" />
   <include package="grok" />
-
-  <!-- Meta configurations. -->
-  <include package="zope.sendmail" file="meta.zcml" />
   <include package="waeup.kofa" file="meta.zcml" />
-
-  <!-- Extra packages we have to configure -->
-  <include package="grokcore.message" />
-  <include package="grokui.admin" />
-  <include package="hurry.zoperesource" />
-  <include package="megrok.layout" />
-  <include package="zc.sourcefactory" />
-  <include package="zope.app.authentication" />
-  <include package="zope.sendmail" />
+  <includeDependencies package="." />
 
   <!-- Comment the following line if you don't want dolmen.beaker,
@@ -26,11 +15,7 @@
        be found by the includeDependencies directive. -->
   <include package="dolmen.beaker" file="configure.zcml" />
+  <grok:grok package="." />
 
-  <include package="waeup.kofa" file="locales.zcml" />
-  <grok:grok package="waeup.kofa" />
-  <!-- The following configurations are large (or expected to become
-       large) and therefore 'outsourced' - the only ethical way to do
-       outsourcing ;-)
-  -->
+  <!-- include package="." file="async.zcml" / -->
   <includeOverrides package="waeup.kofa.widgets" file="overrides.zcml" />
   <includeOverrides package="waeup.kofa.utils" file="overrides.zcml" />
Index: main/waeup.kofa/trunk/src/waeup/kofa/datacenter.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/datacenter.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/datacenter.py	(revision 9217)
@@ -31,4 +31,5 @@
                                    IDataCenterStorageMovedEvent,
                                    IDataCenterConfig)
+from waeup.kofa.utils.batching import ExportJobContainer
 from waeup.kofa.utils.helpers import copy_filesystem_tree, merge_csv_files
 from waeup.kofa.utils.logger import Logger
@@ -37,5 +38,5 @@
 RE_LOGFILE_BACKUP_NAME = re.compile('^.+\.\d+$')
 
-class DataCenter(grok.Container, Logger):
+class DataCenter(grok.Container, Logger, ExportJobContainer):
     """A data center contains CSV files.
     """
Index: main/waeup.kofa/trunk/src/waeup/kofa/ftesting.zcml
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/ftesting.zcml	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/ftesting.zcml	(revision 9217)
@@ -9,4 +9,5 @@
   <includeOverrides package="waeup.kofa" />
   <include package="waeup.kofa" file="mail.zcml" />
+  <include package="waeup.kofa" file="async_single.zcml" />
 
   <!-- Where should the datacenter reside by default? -->
Index: main/waeup.kofa/trunk/src/waeup/kofa/hostels/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/hostels/browser.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/hostels/browser.py	(revision 9217)
@@ -22,5 +22,5 @@
 from zope.i18n import translate
 from zope.component import getUtility
-from waeup.kofa.browser import (
+from waeup.kofa.browser.layout import (
     KofaEditFormPage, KofaAddFormPage, KofaDisplayFormPage,
     NullValidator)
